/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: uip_adpt.h 158 2016-02-20 13:43:32Z coas-nagasima $
 */

#ifndef __UIP_ADPT_H__
#define __UIP_ADPT_H__

#if defined __cplusplus
extern "C" {
#endif

/*
 *  IPv4 AhX
 */

#define T_IN4_ADDR uip_ipaddr_t

/*
 *  ITRON TCP/IPv4 AhX/|[gԍ̒`
 */

typedef struct t_ipv4ep {
	T_IN4_ADDR	ipaddr;		/* IPv4AhX		*/
	uint16_t		portno;		/* |[gԍ		*/
} T_IPV4EP;

#define MAKE_IPV4_ADDR(a,b,c,d) a,b,c,d

typedef struct t_tcp_ccep
{
	T_IN4_ADDR	ripaddr;		/* [gIPv4AhX		*/
	uint16_t		rport;			/* [g|[gԍ		*/
	uint16_t		lport;			/* [J|[gԍ		*/
	void(*callback)(struct uip_conn *uip_conn, int fncd, void *p_parblk);
} T_TCP_CCEP;

struct uip_conn *tcp_acre_cep(const T_TCP_CCEP *pk_ccep);
int tcp_snd_dat(struct uip_conn *cepid, T_IPV4EP *p_dstaddr, void *data, int len);
int tcp_rcv_dat(struct uip_conn *cepid, T_IPV4EP *p_srcaddr, void *data, int len);

typedef struct t_udp_ccep
{
	T_IN4_ADDR	ripaddr;		/* [gIPv4AhX		*/
	uint16_t		rport;			/* [g|[gԍ		*/
	uint16_t		lport;			/* [J|[gԍ		*/
	void (*callback)(struct uip_udp_conn *uip_udp_conn, int fncd, void *p_parblk);
} T_UDP_CCEP;

struct uip_udp_conn *udp_acre_cep(const T_UDP_CCEP *pk_ccep);
int udp_snd_dat(struct uip_udp_conn *cepid, T_IPV4EP *p_dstaddr, void *data, int len);
int udp_rcv_dat(struct uip_udp_conn *cepid, T_IPV4EP *p_srcaddr, void *data, int len);

ER uip_start();
char *ip2str(char *buf, const T_IN4_ADDR ipaddr);
ID uip_getid(struct uip_conn *conn);
struct uip_conn *uip_getconn(ID connid);

#if defined __cplusplus
}
#endif

#endif /* __UIP_ADPT_H__ */
